using System;
using System.Collections.Generic;
using System.Text;
using Syncfusion.Windows.Forms.Diagram;
using Syncfusion.Windows.Forms;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Windows.Forms;

namespace Link_Node_Analysis
{
    public class Item : Syncfusion.Windows.Forms.Diagram.Symbol
    {

        private Syncfusion.Windows.Forms.Diagram.Rectangle outerRect = null;
        private Syncfusion.Windows.Forms.Diagram.CirclePort leftport = null;
        private Syncfusion.Windows.Forms.Diagram.CirclePort rightport = null;
        private TreeNode objTreeNode=null;
        
        
        
        public void SetTreeNode(TreeNode node)
        {
            this.objTreeNode = node;
        }
        public TreeNode GetTreeNode()
        {
            return objTreeNode;     
        }

        public Item(int x, int y, string name)
        {
            // Add an outer rectangle.
            this.outerRect = new Syncfusion.Windows.Forms.Diagram.Rectangle(x, y, 170, 25);
            this.outerRect.Name = "Rectangle";
            this.outerRect.FillStyle.Color = Color.Khaki;
            this.AppendChild(outerRect);

            Syncfusion.Windows.Forms.Diagram.Label lbl = this.AddLabel(name, Syncfusion.Windows.Forms.Diagram.BoxPosition.Center);
            this.Name = name;
            leftport = new Syncfusion.Windows.Forms.Diagram.CirclePort(new PointF(x, (this.Height / 2) + y));
            rightport = new Syncfusion.Windows.Forms.Diagram.CirclePort(new PointF(this.Width + x, (this.Height / 2) + y));

            // Append CirlePorts to MySymbol.
            AppendChild(leftport);
            AppendChild(rightport);

            // Make CenterPort visible.
            //  this.CenterPort.Visible = true;
            this.leftport.Visible = true;
            this.rightport.Visible = true;
        }

    }
}
