using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Diagram;
using Syncfusion.Windows.Forms.Tools.XPMenus;


namespace Link_Node_Analysis
{
    public partial class Form1 : Form
    {
        // different type of links
        enum LinkType {WEAKLINK=1, THINLINK=3, SMARTLINK=5, THICKLINK=7,  STRONGLINK=10};


        Hashtable BusinessEntitiesHashTable=new Hashtable();
        Item BusinessItem,m1,m2,m3;
       
        //TransControl.TransControl transCtl;
        private TransControl transCtl = new TransControl();
        Syncfusion.Windows.Forms.Diagram.LinkCmd lnkCmd;
        public Form1()
        {

            InitializeComponent();
           // LoadSymbolPalette();
         }

        public void CreateLink(Item m1, Item m2, int LinkType)
        {
            lnkCmd = new Syncfusion.Windows.Forms.Diagram.LinkCmd();
            lnkCmd.Link = new Syncfusion.Windows.Forms.Diagram.Link(Syncfusion.Windows.Forms.Diagram.Link.Shapes.Line);

            //manage the thickness of the line
            lnkCmd.Link.LineStyle.LineWidth = LinkType;// linkType.ToString();
            
            
            lnkCmd.SourcePort = m1.CenterPort;
            lnkCmd.TargetPort = m2.CenterPort;
            this.diagram2.Controller.ExecuteCommand(lnkCmd);

        }


        #region Drag n Drop symbols
        private void diagram1_DragEnter(object sender, DragEventArgs e)
        {
            //Allow Drop Cursor only if it is a Diagram Node or a Bitmap
            if ((e.Data.GetDataPresent(typeof(NodeCollection))) | (e.Data.GetDataPresent(DataFormats.Bitmap)) | (e.Data.GetDataPresent(typeof(TreeNode))))
            {
                e.Effect = DragDropEffects.All;
            }
            else
                e.Effect = DragDropEffects.None;	
        }

        private void diagram1_DragDrop(object sender, DragEventArgs e)
        {
            // get the specific type of the da
               TreeNode node = (TreeNode)e.Data.GetData(typeof(TreeNode));

            //get the business items       
              string itemName = node.Name;
              BusinessItem = new Item(250, 250, itemName);
              BusinessItem.SetTreeNode(node);

            // add the business item in the array of business entities  
              diagram1.Model.AppendChild(BusinessItem);
              BusinessEntitiesHashTable.Add(itemName, BusinessItem);


          //  m2 = new Item(100, 100, "12312");

           
        }
        #endregion


       

      


        #region Rotate Item
        protected void RotateNode(Item symbol)
        {
            Syncfusion.Windows.Forms.Diagram.RotateCmd rotate = new Syncfusion.Windows.Forms.Diagram.RotateCmd();
            rotate.Nodes.Add(symbol);
            rotate.Radians = 90;
            this.diagram1.Controller.ExecuteCommand(rotate);
            this.diagram1.Model.UpdateViews();

        }
        #endregion 



        private void btnLink_Click(object sender, EventArgs e)
        {
             this.diagram1.ActivateTool("LinkTool");
        }

       


        protected Link CreateLinkLink(PointF[] pts)
        {
            // to draw simple line
            Link link = new Link(pts);
            return link;
        }

        /**/
        #region Children Change Events

        private void diagram1_ChildrenChangeComplete(object sender, Syncfusion.Windows.Forms.Diagram.NodeCollectionEventArgs evtArgs)
        {
          //  MessageBox.Show("children change complete..........");
            if (evtArgs.ChangeType == Syncfusion.Windows.Forms.Diagram.CollectionExChangeType.Insert)
            {
                foreach (Syncfusion.Windows.Forms.Diagram.INode node in evtArgs.Nodes)
                {
                    if ((node is Syncfusion.Windows.Forms.Diagram.Line) || (node is Syncfusion.Windows.Forms.Diagram.PolyLine) || (node is Syncfusion.Windows.Forms.Diagram.Arc))
                    {

                        Syncfusion.Windows.Forms.Diagram.IPropertyContainer propcntnr = (Syncfusion.Windows.Forms.Diagram.IPropertyContainer)node.GetService(typeof(Syncfusion.Windows.Forms.Diagram.IPropertyContainer));
                        if (propcntnr != null)
                            propcntnr.SetPropertyValue("EnableDynamicLinking", true);
                    }
                }
            }
        }

        private void diagram1_ChildrenChanging(object sender, Syncfusion.Windows.Forms.Diagram.NodeCollectionEventArgs evtArgs)
        {
          //  MessageBox.Show("children changing.........");
            if (evtArgs.ChangeType == Syncfusion.Windows.Forms.Diagram.CollectionExChangeType.Insert)
            {
                foreach (Syncfusion.Windows.Forms.Diagram.INode node in evtArgs.Nodes)
                {
                    if ((node is Syncfusion.Windows.Forms.Diagram.Symbol) && (node.Name != null) && (node.Name.ToLower().IndexOf("connector") >= 0))
                    {
                        Syncfusion.Windows.Forms.Diagram.Symbol symbolnode = node as Syncfusion.Windows.Forms.Diagram.Symbol;
                        Syncfusion.Windows.Forms.Diagram.INode childnode = symbolnode.Nodes.First;
                        if ((childnode is Syncfusion.Windows.Forms.Diagram.Line) || (childnode is Syncfusion.Windows.Forms.Diagram.PolyLine) || (childnode is Syncfusion.Windows.Forms.Diagram.Arc))
                        {
                            Syncfusion.Windows.Forms.Diagram.Shape childshape = childnode as Syncfusion.Windows.Forms.Diagram.Shape;
                            PointF location = symbolnode.Location;
                            symbolnode.Nodes.Remove(childshape);
                            childshape.LocalTransform.Reset();
                            Syncfusion.Windows.Forms.Diagram.InsertNodesCmd inscmd = new Syncfusion.Windows.Forms.Diagram.InsertNodesCmd();
                            inscmd.AddNode(childnode, new PointF(100, 120));
                            this.diagram1.Controller.ExecuteCommand(inscmd);
                            evtArgs.Cancel = true;
                        }
                    }
                }
            }
        }

        #endregion


        #region Form Load
        private void Form1_Load(object sender, EventArgs e)
        {
            this.overviewControl1.Model = diagram1.Model;
            this.overviewControl1.View = diagram1.View;


            
            /********************************************/
            //Create and Register the Link Tool for the custom link
            Tool linkTool = this.diagram1.Controller.GetTool("LinkTool");
            ((LinkTool)linkTool).LinkFactory = new LinkFactory(this.CreateLinkLink);
             this.diagram1.Controller.RegisterTool(linkTool);
        }
        #endregion

        private void button1_Click(object sender, EventArgs e)
        {
            if (this.saveFileDialog1.ShowDialog(this) == DialogResult.OK)
            {
                this.diagram1.SaveBinary(this.saveFileDialog1.FileName);
            }
        }

       

        private void tabControl1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if(tabControl1.SelectedIndex.ToString().Equals("1") )
                Execute();
            //diagram2.View.pr
             // MessageBox.Show("Do u want to execute the design");

        
        }

        

        private void treeView1_ItemDrag(object sender, ItemDragEventArgs e)
        {
            DoDragDrop(e.Item, System.Windows.Forms.DragDropEffects.All);
        }

        protected void CreateAndRegisterLinkTools()
        {
            Tool linkTool = this.diagram1.Controller.GetTool("LinkTool");
            if (linkTool != null && linkTool.GetType() == typeof(LinkTool))
            {
                ((LinkTool)linkTool).LinkFactory = new LinkFactory(this.CreateLinkLink);
            }

            // Create and register a tool for orthogonal links
            OrthogonalLinkTool orthogonalLinkTool = new OrthogonalLinkTool(this.diagram1.Controller);

            this.diagram1.Controller.RegisterTool(orthogonalLinkTool);

            // Create and register a tool for directed links
            DirectedLineLinkTool directedLinkTool = new DirectedLineLinkTool(this.diagram1.Controller);

            this.diagram1.Controller.RegisterTool(directedLinkTool);

            // Create and register a tool for arc links
            ArcLinkTool arcLinkTool = new ArcLinkTool(this.diagram1.Controller);

            this.diagram1.Controller.RegisterTool(arcLinkTool);

            // Set focus to the diagram control
            // Create and register a tool for custom links
            LinkTool customLinkTool = new LinkTool(this.diagram1.Controller);
            customLinkTool.Name = "CustomLinkTool";
           // customLinkTool.LinkFactory = new LinkFactory(this.CreateCustomLink);
            this.diagram1.Controller.RegisterTool(customLinkTool);

        }

        #region Execution Block

        private void Execute()
        {
            int size = BusinessEntitiesHashTable.Count;
            int verticalLocation = 150;

            Item BItem1 = (Item)BusinessEntitiesHashTable["Product"];
            Item []ItemProductArray= new Item[size];
            

            TreeNode node = BItem1.GetTreeNode();
            string NodePreFixName = node.Name;
            node = node.FirstNode;
            //int a = 0;
            for (; node != null; node = node.NextNode)
            {

                BItem1 = new Item(100, verticalLocation, NodePreFixName + "_" + node.Name);
                diagram2.Model.AppendChild(BItem1);
                verticalLocation = verticalLocation + 75;
               // a++;
            }


            /*********************************************************************************/









            Item businessItem = (Item)BusinessEntitiesHashTable["Customer"];
            node = businessItem.GetTreeNode();
            NodePreFixName = node.Name;
            node = node.FirstNode;

            for (; node != null; node = node.NextNode)
            {
                //  MessageBox.Show(node.Name);
                BusinessItem = new Item(300, verticalLocation, NodePreFixName + "_" + node.Name);
                diagram2.Model.AppendChild(BusinessItem);


                TreeNode childNode = node.FirstNode;
                for (; childNode != null; childNode = childNode.NextNode)
                {

                    //  MessageBox.Show(childNode.Name);
                    Item temp = (Item)diagram2.Model.GetChildByName("Product_" + childNode.Text);
                    CreateLink(BusinessItem, temp, Convert.ToInt32(childNode.Name)); 
                    
                    //BusinessItem = new Item(300, verticalLocation, NodePreFixName + node.Name);
                    //diagram2.Model.AppendChild(BusinessItem);
                    //MessageBox.Show(childNode.Name);
                }

            }
            
            
            
            //for (int i = 0; i < node.GetNodeCount(false); i++)
            //{
            //    MessageBox.Show(node.Name);
            //    node = node.FirstNode;
            //}

        }

        #endregion

        private void button2_Click(object sender, EventArgs e)
        {
            int count=diagram1.Model.ChildCount;
            INode node=diagram1.Model.GetChildByName("Product");
        }
    }


    

}