using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace Link_Node_Analysis
{
	/// <summary>
	/// Summary description for TransControl.
	/// </summary>
	public class TransControl : System.Windows.Forms.Panel
	{
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private Label topBorder = new Label();
		private Label leftBorder = new Label();
		private Label bottomBorder = new Label();
		private Label rightBorder = new Label();

		public int XOffset=0;
		public int YOffset=0;
		public int MagnificationFactor=0;

		private int x;
		private int y;
		private int left;
		private int top;
		private bool isMouseDown=false;

		public TransControl()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call
					
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		protected override CreateParams CreateParams 
		{ 
			get 
			{ 
				CreateParams cp=base.CreateParams; 
				cp.ExStyle|=0x00000020; //WS_EX_TRANSPARENT 
				return cp; 
			} 
		} 

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// TransControl
			// 
			this.Name = "TransControl";
//			this.Load += new System.EventHandler(this.TransControl_Load);
			this.Controls.Add(topBorder);
			this.Controls.Add(rightBorder);
			this.Controls.Add(leftBorder);
			this.Controls.Add(bottomBorder);
			
			this.MouseDown += new MouseEventHandler(this_MouseDown);
			this.MouseMove += new MouseEventHandler(this_MouseMove);
			this.MouseUp += new MouseEventHandler(this_MouseUp);


			AddBorders();

		}
		#endregion

		protected override void OnPaint(PaintEventArgs e)
		{
			AddBorders();
		}
		
		protected override void OnPaintBackground(PaintEventArgs pevent)
		{
			pevent.Graphics.DrawImage(null,new Rectangle(0,0,this.Width,this.Height),this.Left + XOffset,this.Top + YOffset,this.Width-(MagnificationFactor/10),this.Height-(MagnificationFactor/10), GraphicsUnit.Pixel);

		}

		protected void this_MouseMove(object sender, MouseEventArgs e)
		{
			if(isMouseDown)
			{
				this.Left = this.Left + (e.X-x);
				this.Top = this.Top + (e.Y-y);

				//Refresh the parent to ensure that whatever is behind the control gets painted 
				//before we need to do our own graphics output.
				this.Parent.Refresh();
			}
		}

		protected void this_MouseDown(object sender, MouseEventArgs e)
		{
			x= e.X;
			y=e.Y;
			left=this.Left;
			top=this.Top;
			isMouseDown=true;
			this.Cursor= Cursors.SizeAll;
		}


		protected void this_MouseUp(object sender, MouseEventArgs e)
		{
			isMouseDown=false;
			this.Cursor= Cursors.Default;
			this.Refresh();
		}


		private void AddBorders()
		{

			topBorder.Location = new Point(0,0);
			topBorder.Size = new Size(this.Width,10);
			topBorder.BackColor = Color.Black;
		
			leftBorder.Location = new Point(0,0);
			leftBorder.Size = new Size(1,this.Height);
			leftBorder.BackColor = Color.Black;
			
			rightBorder.Location = new Point(this.Width-1,0);
			rightBorder.Size = new Size(1,this.Height);
			rightBorder.BackColor = Color.Black;
						
			bottomBorder.Location = new Point(0,this.Height-1);
			bottomBorder.Size = new Size(this.Width,1);
			bottomBorder.BackColor = Color.Black;
			

		}
	}
}
